#
# This file is part of Barista.
# Copyright (C) 2007-2014 Xavier Clerc.
#
# Barista is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# Barista is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

.class public final pack.Test
.extends java.lang.Object

.method public static void optimize_discarded()
        ldc 10
        iconst_5
        iadd
        pop
        return

.method public static int optimize_integers()
        ldc 17
        ldc 12
        isub
        ireturn

.method public static long optimize_longs()
        ldc2_w 34
        ldc2_w -12
        ladd
        bipush 11
        i2l
        ldiv
        lconst_1
        lsub
        lreturn

.method public static float optimize_floats()
        ldc 19
        ldc 17
        isub
        i2f
        freturn

.method public static double optimize_doubles()
        ldc2_w 34
        ldc2_w -17
        ldiv
        lneg
        lconst_1
        lsub
        l2d
        dreturn

.method public static void optimize_locals(double,float,int,long)
        iload 3
        iconst_1
        iadd
        pop
        iconst_3
        i2l
        lstore 4
        fload_2
        fconst_0
        fdiv
        pop
        lload 4
        ldc2_w 7
        ladd
        lstore 4
        return

.method public static void swap()
        iconst_0
        iconst_1
        swap
        iadd
        return

.method public static int optimize_iinc(int)
        iconst_0
        istore_1
        iinc 0 1
        iload_0
        iconst_2
        iadd
        iinc 1 5
        iload_1
        iconst_3
        isub
        ireturn

.method public static void neutral_elements(float, int)
        iload_1
        iconst_5
        iconst_4
        isub
        ldc -1
        iadd
        iadd
        i2l
        lconst_1
        lmul
        fload_0
        f2l
        lconst_1
        lrem
        ladd
        return

.method public static void absorbing_elements(int)
        iload 0
        ldc 0
        imul
        iload 0
        ldc 1
        irem
        return

.method public static int optimize_switches(int,int)
        iconst_1
        lookupswitch default: 3
                     0 => zero:
                     1 => one:
                     3 => three:
zero:
        iload_1
        ireturn
one:
        iload_1
        iconst_1
        iadd
        ireturn
three:
        iload_1
        iload_1
        imul
        ireturn
default:
        iconst_m1
        ireturn

.method public static int optimize_switches2(int,int)
        iconst_5
        iconst_2
        tableswitch default: 0 2
                     => zero:
                     => one:
                     => two:
zero:
        iload_1
        ireturn
one:
        iload_1
        iconst_1
        iadd
        ireturn
two:
        iload_1
        iload_1
        imul
        ireturn
default:
        iconst_m1
        ireturn

.method public static int optimize_jumps1(int)
        aconst_null
        ifnull next:
        goto end:
next:
        iconst_1
        ireturn
end:
        iconst_0
        ireturn

.method public static int optimize_jumps2(int)
        aconst_null
        ifnonnull next:
        goto end:
next:
        iconst_1
        ireturn
end:
        iconst_0
        ireturn

.method public static int optimize_jumps3(int)
        iconst_3
        ldc_w 7
        if_icmplt true:
        goto false:
true:
        iconst_1
        ireturn
false:
        iconst_0
        ireturn

.method public static int optimize_jumps4(int)
        iconst_3
        ldc_w 7
        if_icmpge true:
        goto false:
true:
        iconst_1
        ireturn
false:
        iconst_0
        ireturn

.method public static int optimize_jumps5(int)
        iconst_m1
        iflt true:
        goto false:
true:
        iconst_1
        ireturn
false:
        iconst_0
        ireturn

.method public static int optimize_jumps6(int)
        iconst_1
        iconst_0
        ifne true:
        goto false:
true:
        iconst_1
        ireturn
false:
        iconst_0
        ireturn

.method public static int optimize_jumps7(long)
        lload_0
        bipush 31
        i2l
        lcmp
        ifeq conv:
        iconst_0
        goto after:
conv:
        iconst_1
after:
        ifeq ret1:
        iconst_0
        ireturn
ret1:
        iconst_1
        ireturn

.method public static int optimize_jumps8(long)
        lload_0
        bipush 31
        i2l
        lcmp
        ifeq conv:
        lconst_1
        goto after:
conv:
        lconst_0
after:
        l2i
        ifeq ret1:
        iconst_0
        ireturn
ret1:
        iconst_1
        ireturn

.method public static void optimize_bug_infinite_loop(long)
start:
        goto start:
        return

.method public static void main(java.lang.String[])
        return
